define(['exports', '@angular/core', '@angular/platform-browser', '@angular/router', '@angular/animations', '@angular/common', '@angular/platform-browser/animations'], function (exports, core, platformBrowser, router, animations, common, animations$1) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var baseAnimation = animations.trigger('baseAnimation', [
    animations.state('void', animations.style({ position: 'fixed', opacity: 0 })),
    // route 'enter' transition
    animations.transition(':enter', [
        // css styles at start of transition
        animations.style({ opacity: 0, "z-index": "1001" }),
        // animation and styles at end of transition
        animations.animate('20s', animations.style({ opacity: 1, "z-index": "1001" }))
    ]),
    animations.transition(':leave', [
        // css styles at start of transition
        animations.style({ opacity: 1 }),
        // animation and styles at end of transition
        animations.animate('20s', animations.style({ opacity: 0 }))
    ]),
]);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ModalOutletComponent = /** @class */ (function () {
    function ModalOutletComponent() {
    }
    ModalOutletComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'modal-outlet',
                    template: "\n    <router-outlet name=\"modal\"></router-outlet>\n  ",
                    animations: []
                },] },
    ];
    /** @nocollapse */
    ModalOutletComponent.ctorParameters = function () { return []; };
    return ModalOutletComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ModalService = /** @class */ (function () {
    function ModalService(router$$1) {
        this.router = router$$1;
    }
    /**
     * @param {?} name
     * @return {?}
     */
    ModalService.prototype.open = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        this.router.navigate([{ outlets: { modal: [name] } }], { skipLocationChange: true });
    };
    /**
     * @return {?}
     */
    ModalService.prototype.close = /**
     * @return {?}
     */
    function () {
        this.router.navigate([{ outlets: { modal: null } }], { skipLocationChange: true });
    };
    ModalService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    ModalService.ctorParameters = function () { return [
        { type: router.Router, decorators: [{ type: core.Inject, args: [router.Router,] },] },
    ]; };
    return ModalService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ModalDialogComponent = /** @class */ (function () {
    function ModalDialogComponent(modalService) {
        this.modalService = modalService;
    }
    /**
     * @return {?}
     */
    ModalDialogComponent.prototype.close = /**
     * @return {?}
     */
    function () {
        this.modalService.close();
    };
    ModalDialogComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'modal-dialog',
                    template: "\n    <div  @baseAnimation>\n    <div  class=\"modal fade in show\" tabindex=\"-1\" role=\"dialog\">\n        <div class=\"modal-dialog modal-lg\" role=\"document\">\n          <div class=\"modal-content\">\n            <div class=\"modal-header\">\n              <button type=\"button\" (click)=\"close()\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\"><span aria-hidden=\"true\">&times;</span></button>\n              <h4 class=\"modal-title\">\n                <ng-content select=\"[modal-title]\"></ng-content>\n              </h4>\n            </div>\n            <div class=\"modal-body\">\n                <ng-content select=\"[modal-body]\"></ng-content>\n            </div>\n            <div class=\"modal-footer\">\n                <div #footer>\n                    <ng-content select=\"[modal-footer]\"></ng-content>\n                </div>\n                <div *ngIf=\"footer.children.length == 0\">\n                    <button (click)=\"close()\" type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\">Close</button>\n                    <button type=\"button\" class=\"btn btn-primary\">Submit</button>\n                </div>\n            </div>\n          </div>\n        </div>\n      </div>\n      <div class=\"modal-backdrop fade in\"></div>\n\n    </div>\n  ",
                    animations: [
                        baseAnimation
                    ]
                },] },
    ];
    /** @nocollapse */
    ModalDialogComponent.ctorParameters = function () { return [
        { type: ModalService, },
    ]; };
    return ModalDialogComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
//import { ANALYZE_FOR_ENTRY_COMPONENTS } from "@angular/core";
var Modals = new core.InjectionToken('modals');
/**
 * @param {?} router
 * @param {?} modals
 * @return {?}
 */
function InitModalService(router$$1, modals) {
    var /** @type {?} */ routes = modals.map(function (t) { return { path: t.name, component: t.component, outlet: 'modal' }; });
    var /** @type {?} */ r = router$$1.config.concat(routes);
    router$$1.resetConfig(r);
    return new ModalService(router$$1);
}
var ModalCommonModule = /** @class */ (function () {
    function ModalCommonModule() {
    }
    ModalCommonModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        animations$1.BrowserAnimationsModule,
                        router.RouterModule.forChild([])
                    ],
                    declarations: [
                        ModalDialogComponent,
                        ModalOutletComponent
                    ],
                    exports: [
                        ModalDialogComponent,
                        ModalOutletComponent
                    ],
                    providers: []
                },] },
    ];
    /** @nocollapse */
    ModalCommonModule.ctorParameters = function () { return []; };
    return ModalCommonModule;
}());
var RouterModalModule = /** @class */ (function () {
    function RouterModalModule() {
    }
    /**
     * @param {?} modals
     * @return {?}
     */
    RouterModalModule.forRoot = /**
     * @param {?} modals
     * @return {?}
     */
    function (modals) {
        var /** @type {?} */ routes = modals.map(function (t) { return { path: t.name, component: t.component, outlet: 'modal' }; });
        return {
            ngModule: RouterModalModule,
            providers: [
                { provide: Modals, useValue: modals },
                { provide: core.ANALYZE_FOR_ENTRY_COMPONENTS, multi: true, useValue: modals },
                { provide: ModalService, useFactory: InitModalService, deps: [router.Router, Modals] }
            ]
        };
    };
    RouterModalModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        ModalCommonModule
                    ],
                    exports: [
                        ModalCommonModule
                    ]
                },] },
    ];
    /** @nocollapse */
    RouterModalModule.ctorParameters = function () { return []; };
    return RouterModalModule;
}());
var ModalModule = /** @class */ (function () {
    function ModalModule() {
    }
    /**
     * @param {?} modals
     * @return {?}
     */
    ModalModule.forRoot = /**
     * @param {?} modals
     * @return {?}
     */
    function (modals) {
        return {
            ngModule: ModalModule,
            providers: [
                { provide: Modals, useValue: modals },
                { provide: core.ANALYZE_FOR_ENTRY_COMPONENTS, multi: true, useValue: modals },
                { provide: ModalService, useFactory: InitModalService, deps: [router.Router, Modals] }
            ]
        };
    };
    ModalModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        ModalCommonModule,
                        router.RouterModule.forRoot([])
                    ],
                    exports: [
                        ModalCommonModule
                    ],
                    providers: []
                },] },
    ];
    /** @nocollapse */
    ModalModule.ctorParameters = function () { return []; };
    return ModalModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
/**
 * @module
 * @description
 * Entry point for all public APIs of the core package.
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

exports.Modals = Modals;
exports.InitModalService = InitModalService;
exports.ModalCommonModule = ModalCommonModule;
exports.RouterModalModule = RouterModalModule;
exports.ModalModule = ModalModule;
exports.ModalService = ModalService;
exports.ɵa = ModalDialogComponent;
exports.ɵc = ModalOutletComponent;
exports.ɵb = baseAnimation;

Object.defineProperty(exports, '__esModule', { value: true });

});
//# sourceMappingURL=ng-bootstrap-modal.amd.js.map
